SELECT MAX(ID)
FROM BAKERY_ITEM;

SELECT ITEM_TYPE
FROM BAKERY_ITEM
WHERE ITEM_TYPE = 'MUFFIN'
GROUP BY ITEM_TYPE;

SELECT ITEM_TYPE
FROM BAKERY_ITEM
GROUP BY ITEM_TYPE
HAVING ITEM_TYPE = 'MUFFIN';

SELECT * 
FROM BAKERY_ITEM bi;

SELECT * 
FROM BAKERY_ORDER bo;

SELECT *
FROM BAKERY_ORDER_ITEM boi; 

SELECT CUSTOMER "Customer Name" -- using a column alias 
FROM BAKERY_ORDER bo -- bo is a table alias
JOIN BAKERY_ORDER_ITEM boi 
ON bo.ID = boi.ORDER_ID

SELECT *
FROM BAKERY_ORDER bo
JOIN BAKERY_ORDER_ITEM boi 
ON bo.ID = boi.ORDER_ID
JOIN BAKERY_ITEM bi 
ON boi.ITEM_ID = bi.ID;

SELECT bo.CUSTOMER, bi.ITEM_TYPE, bi.MUFFIN_FLAVOR, bi.BREAD_TYPE, bi.COFFEE_ROAST, bi.COFFEE_SIZE 
FROM BAKERY_ORDER bo
JOIN BAKERY_ORDER_ITEM boi 
ON bo.ID = boi.ORDER_ID
JOIN BAKERY_ITEM bi 
ON boi.ITEM_ID = bi.ID;

-- FULL OUTER = OUTER
-- LEFT OUTER = LEFT
-- RIGHT OUTER = RIGHT 
-- INNER JOIN = JOIN

SELECT * 
FROM BAKERY_ORDER bo 
LEFT OUTER JOIN BAKERY_ORDER_ITEM boi 
ON bo.ID = boi.ORDER_ID 
LEFT OUTER JOIN BAKERY_ITEM bi  
ON boi.ITEM_ID = bi.ID;


SELECT * FROM BAKERY_ITEM;

SELECT ITEM_TYPE 
FROM BAKERY_ITEM bi 
GROUP BY ITEM_TYPE;


---------------------------------------------
-- CREATING SEQUENCES FOR AUTO-GENERATED PK'S
---------------------------------------------

CREATE SEQUENCE SQ_BAKERY_ITEM_PK
START WITH 14
INCREMENT BY 1;

CREATE SEQUENCE SQ_BAKERY_ORDER_PK
START WITH 103
INCREMENT BY 1;

CREATE SEQUENCE SQ_BAKERY_ORDER_ITEM_PK
START WITH 55
INCREMENT BY 1;

---------------------------------------------
--CREATING SEQUENCES FOR AUTO-GENERATED PK'S
---------------------------------------------

CREATE OR REPLACE TRIGGER TR_INSERT_BAKERY_ITEM_PK
BEFORE INSERT ON BAKERY_ITEM
FOR EACH ROW 
BEGIN 
	SELECT SQ_BAKERY_ITEM_PK.NEXTVAL INTO :NEW.ID FROM DUAL;
END;
/

CREATE OR REPLACE TRIGGER TR_INSERT_BAKERY_ORDER_PK
BEFORE INSERT ON BAKERY_ORDER
FOR EACH ROW 
BEGIN 
	SELECT SQ_BAKERY_ORDER_PK.NEXTVAL INTO :NEW.ID FROM DUAL;
END;
/

CREATE OR REPLACE TRIGGER TR_INSERT_BAKERY_ORDER_ITEM_PK
BEFORE INSERT ON BAKERY_ORDER_ITEM
FOR EACH ROW
BEGIN 
	SELECT SQ_BAKERY_ORDER_ITEM_PK.NEXTVAL INTO :NEW.ID FROM DUAL;
END;
/

-------------------------------------
-- TESTING OUT OUR TRIGGERS
-------------------------------------

INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, MUFFIN_FLAVOR) VALUES ('MUFFIN',3.75,'CHOCOLATE');

--SELECT SQ_BAKERY_ITEM_PK.NEXTVAL FROM DUAL;

INSERT INTO BAKERY_ORDER (CUSTOMER) VALUES ('STELLA');

INSERT INTO BAKERY_ORDER_ITEM (ORDER_ID, ITEM_ID) VALUES (103,15);